Please backport openjdk-8 from Xenial to Trusty

Bug #1368094 reported by Marius B. Kotsbak on 2014-09-11
This bug affects 766 people
Affects Status Importance Assigned to Milestone
trusty-backports
Undecided
Nfally

Bug Description

Please backport openjdk-8 from Xenial to Trusty.

Reason for the backport:
========================
To support developing for JDK 8 and running Java applications requiring JRE 8.

Testing:
========
Mark off items in the checklist [X] as you test them, but please leave the checklist so that backporters can quickly evaluate the state of testing.

Backported packages available from Nicolas DERIVE PPA: https://launchpad.net/~kalon33/+archive/ubuntu/gamesgiroll

Also you can test-build the backport in your PPA with backportpackage:
$ backportpackage -u ppa:<lp username>/<ppa name> -s utopic -d trusty openjdk-8

* trusty:
[ ] Package builds without modification (seems to be missing dependencies, builds with dependency on g++-4.8 instead of g++-4.9)
[ ] openjdk-8-doc installs cleanly and runs
[X] openjdk-8-jdk installs cleanly and runs
[X] openjdk-8-jre-headless installs cleanly and runs
[ ] openjdk-8-jre-zero installs cleanly and runs
[ ] openjdk-8-jre installs cleanly and runs
[ ] openjdk-8-source installs cleanly and runs
[ ] openjdk-8-dbg installs cleanly and runs
[ ] openjdk-8-demo installs cleanly and runs
[ ] openjdk-8-jre-jamvm installs cleanly and runs

No reverse dependencies

description: updated
description: updated
Iain Lane (laney) wrote :

hi doko, do you think backporting openjdk-8 is reasonable? Note https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=761273 which was inspired by this.

Matthias Klose (doko) wrote :

see https://launchpad.net/~openjdk-r/+archive/ubuntu/ppa

who would commit to updating this package in -backports?

Iain Lane (laney) wrote :

Anyone could file a bug to update the package, without rdepends the process is pain free. Maybe Marius would like to volunteer to keep an eye on openjdk-8 updates in U. The backports team still has a desire to implement some reporting for out of date packages, but nobody has taken this work on yet.

Saikrishna Arcot (saiarcot895) wrote :

In my PPA (https://launchpad.net/~saiarcot895/+archive/ubuntu/myppa), I have openjdk-8 version 8u20~b26-0ubuntu1. I can confirm that, from this slightly-modified version, the packages openjdk-8-jre, openjdk-8-jdk, openjdk-8-jre-headless, and openjdk-8-source install and work for normal usage. My package also sets Java 8 to be the default Java version.

Saikrishna Arcot (saiarcot895) wrote :

Also, for the build-dependency, debian/rules seems to insert g++-4.8 into debian/control when it's on Trusty, so if the generation of the debian/control file happens on Trusty, no manual changes should be needed.

Muhammad Annaqeeb (annaqeeb) wrote :

+1 Backporting openJDK 8 would be nice; as Oracle JDK 7 End Of Life is next month, users of Oracle JDK will migrate to 8, while users of openJDK will not be able to cope up with them , unless the backporting happens before that.

Tamas Papp (tomposmiko) wrote :

Why isn't there any update on this?

Matthias Klose (doko) wrote :

this issue is clearly missing somebody who is doing the work. marking as incomplete.

Changed in trusty-backports:
status: New → Incomplete
Jens Rantil (jens-rantil) wrote :

+1 This is on my wishlist, too.

James Judd (jame5) wrote :

+1 Would love to see openjdk8 backported.

+1 same for me.

Thayne (thayne-u) wrote :

What is incomplete about the ticket?

Saikrishna Arcot (saiarcot895) wrote :

Someone needs to verify that the items in the checklist in the main bug description work (that the programs install cleanly and run).

Dan Muresan (danmbox) wrote :

Who needs to verify? Someone did verify in #4...

TJ (tj) on 2015-05-14
Changed in trusty-backports:
assignee: nobody → TJ (tj)
status: Incomplete → In Progress
TJ (tj) wrote :

I've currently got backports from Vivid to Trusty of:

 openjdk-8 8u45-b14-1
 openjfx 8u40-b25-1

 in a PPA for testing.

https://launchpad.net/~tj/+archive/ubuntu/java-for-14.04/

I'm going to be doing thorough testing of them via several demanding Java projects over the coming week or so.

In order to successfully build openjfx several other packages, required only for building, had to be backported too (libasm4-java, spock, werken.xpath [bug #1455275 in library symlink).

All of the backports needed tweaks to either their build-depends or their debian/rules to force explicit use of the Java-8 JRE/JDK.

I'd like some feedback on whether those build-depends backports would be accepted into Trusty in order to enable the backport of OpenJFX, which has become a core part of Java-8 providing long-demanded media handling support.

Having Java-8 in the repository without OpenJFX for the LTS would, I foresee, invite demands and bug reports for missing major functionality.

Package Section Changes
libasm4-java java Support for ASM5
spock universe/misc Required by gradle; needed to build against Java-8
werken.xpath universe/misc Required by gradle; bug-fix of bad symlink /usr/share/java/werken.xpath-java

The problem is that these packages need to build against Java-8 in order to be useful but that might cause regressions in the building of other packages that build-depend on them but are targeted at Trusty's Java-6 or Java-7. I intend to work through their reverse-depends lists to determine if there are any problems but that will take some time.

Saikrishna Arcot (saiarcot895) wrote :

Wouldn't a backport for OpenJFX (and other packages that need to be backported) require a separate backport request?

James Judd (jame5) wrote :

Considering we now have backports in a PPA, what is the next step?

Micah Gersten (micahg) wrote :

There should be a separate backports request for each source package that needs backporting. Any dependency chains should be mentioned in the description of each bug.

Micah Gersten (micahg) wrote :

Also, as OpenJDK is prone to frequent security updates, I would only backport this on the condition that people are willing to test each security update as a new backport request.

Java is switching from Swing/SWT to JavaFX, which is included in openjdk-8 but not openjdk-7. For software based on JavaFX it currently looks like LTS users will need to wait another year before the software can be used on official Ubuntu. Particularly for new projects this makes for an uncomfortable decision: Use current technology and have to munge the LTS installation to make use of it, switch to non-LTS releases, or develop for obsolete technology? A backport would make those decisions easier and would be appreciated.

HRJ (harshad-rj) wrote :

@fuzzyBSc

AFAIK, JavaFX is not a standard yet. It is bundled along with Oracle JRE, but not a requirement for Java 8 SE. Many other Java 8 SE JREs don't bundle JavaFX. So, if you want to target a standard platform, JavaFX is *not* an obvious choice.

Fred Cooke (fred-cooke) wrote :

We need this here, too! Side note: The "you are not subscribed" text/link is a poor and unintuitive way to present a subscribe button. Subscribed!

yannickm (yannickm) wrote :

Java is very widely used by corporates and businesses all over the world.

Taking into consideration that oracle java 8 is already out-of-life, the lack of proper java support in ubuntu LTS is rather shocking and will turn off many potential adopters who will think ubuntu is just a "toy" and instead turn (or more likely continue using) Red Hat.

Asa Zernik (asaz989) wrote :

TJ: any updates?

Bram Klein Gunnewiek (i-bram) wrote :

@yannickm "Taking into consideration that oracle java 8 is already out-of-life" -> What do you mean with that?

We badly need support for a maintained java8 jdk on ubuntu

+1. Please backport OpenJDK 8 to Ubuntu 14.04 trusty. We need it badly in our organisation to run SAP apps.

Alex Mougel (alex-mougel) wrote :

+1

Unlogic (unlogic-unlogic) wrote :

+1

Now that Ubuntu 14.10 "Utopic" is EOL'd, is backporting utopic's openjdk8 a good idea? Isn't it better to have Ubuntu 15.10 "Wily Werewolf"'s OpenJDK 8u66-b01-4 backported? See the latest openjdk-8 package in Ubuntu: https://launchpad.net/ubuntu/+source/openjdk-8 . Or better, since the next LTS (Ubuntu 16.04LTS) is just 6 months away, why not backport from it?

Mark Kirk (mklists) wrote :

I'm dismayed that this has been going on for a year now (several other tickets plead for Java 8 on 14.04). It seriously makes me question whether Ubuntu is the right server distro to be running. I thought Canonical was going to support 14.04 LTS for 5 years. Support shouldn't mean frozen in time.

Java 7 defaults to older TLS versions (especially on client connections) and it's sometimes difficult to force TLSv1.2 when you can't change the source code of a library. Java 8 bypasses these problems, so getting 8 on 14.04 is really a security issue, too.

It seems like doing this is mired in some weird bureaucratic black hole.

Simon Déziel (sdeziel) wrote :

I've had good results with this PPA: https://launchpad.net/~openjdk-r/+archive/ubuntu/ppa

New JDK updates are made available relatively quickly even if it's lagging a bit ATM. The JDK 8 update 66 entered Wily on Sept 13th so it shouldn't be too long before it reaches the PPA.

+1
Need it to run apache-jena-fuseki-2.3.0

Java 7 is End of Life'd since April: https://www.java.com/en/download/faq/java_7.xml so third party software built with an up-to-date Java won't work on Trusty (and Precise), which are still supported, without installing a PPA.

New releases (starting with 16.04 LTS) should default to OpenJDK 8, and it would be nice to backport OpenJDK 9 (http://openjdk.java.net/projects/jdk9/) as soon as possible to prevent this issue in a future (Java 8 EOL is estimated to be in September 2017 according to http://www.oracle.com/technetwork/java/eol-135779.html).

On 13.10.2015 11:48, cousteau wrote:
> Java 7 is End of Life'd since April:
> https://www.java.com/en/download/faq/java_7.xml

this is only true for the binaries distributed from java.com. OpenJDK 7 is
*not* End of Life.

The fact that the latest stable and maintained version of Java (8) is not available on the latest LTS is rather strange.

Peter (petru-severin) wrote :

Note that the next version of Eclipse 4.6 Mars (milestone versions already available) will only work with Java 8. Eclipse is also a platform with RCP applications built on it, like WireframeSketcher (my software). Until now I could easily create a deb package with default-jre dependency. With the next version of Eclipse it won't be possible because Java 8 is not available on Ubuntu.

Play framework from version 2.4 requires Java 8.

summary: - Please backport openjdk-8 8u40~b04-2 (universe) from utopic
+ Please backport openjdk-8 8u66-b17-1 (universe) from wily
description: updated
Angus Fox (angusf) wrote :

+1

Alkis Mylonidis (amylonid-u) wrote :

+1

Tim Bishop (tdb) wrote :

I'd like to see this too, but if I had to guess I expect somebody is trying their best to ignore this until April when they can simply say "upgrade to 16.04 LTS"...

pootow (pootow-7) wrote :

ubuntu 1404 EOL is 1804, am I right?

Tim Bishop (tdb) wrote :
abssorb (abssorb) wrote :

+1

"Reason for the backport:"

>>>>>>> 14.04 is LTS! <<<<<<<<<<

jose (o1485726) wrote :

Google is moving their android stack to OpenJDK. Meanwhile, the stable distro used by devs, Ubuntu 14.04, doesn't even have OpenJDK 8.
Great job, canonical.

+1

+1

DJ Molny (djmolny) wrote :

+1

Attila Kádár (atus) wrote :

+1

Ian Eave (ianb136) wrote :

+1 What's the point of offering a LTS if the "S" just stands for "Stagnant"?

Kenny Root (kennyr) wrote :

Looks like Android will require OpenJDK 8 soon:
https://android-review.googlesource.com/196876

Michael Osipov (michael-o) wrote :

+1

Sukumar (s-ghorai) wrote :

+1

Sukumar (s-ghorai) wrote :

Android require OpenJDK 8? Java 8 is not sufficient to build Android?

Charles Smith (softwar-o) wrote :

I take it from the above comments that any project that requires JDK8 may have to wait till April 16 release - and by "may" there is no assurance that 16.04 will contain JFX either. Not good at all. ECLIPSE can support JDK8 and my other operating systems (which will remain nameless) do as well but development on ubuntu has come to a grinding halt.

Byron L. Hargett (a-byron) wrote :

+1

Borna Novak (dosadnizub) wrote :

+1

Borna Novak (dosadnizub) wrote :

Sqldeveloper for Oracle requires Java8 :cripes:

Saurabh (0saurabhgour) wrote :

+1

Alex Kot (alexykot) wrote :

+1

JieCheng (909993131-8) wrote :

+1

+1

Leon Rozanov (schekn) wrote :

+1

Zogg (zoggified) wrote :

+1

If people would like to move this backport forward, I need commitments from people to test backports regularly (average is once per month) as security updates are released. We need to test a decent subset of the reverse dependencies when a new update is released to insure we don't break the backport.

Please stop these +1. That is what "this bug affects me" function is used for. And instead please help with the required testing.

Malte S. Stretz (mss) wrote :

Is testing reverse dependencies really an issue here since the package uses both the alternatives system and virtuals? It can be installed parallel to OpenJDK 7 and if people run into issues they can just switch back to OpenJDK 7 via update-alternatives.

Testing all the possible reverse dependencies probably impossible while this package is clearly needed by many.

Don-vip (vincent-privat) wrote :

What is to be tested? The last valuable update in #15 (2015-05-15) does not mention any blocking problem to backport openjdk-8:
- we can live without openjfx
- is it really needed to check all reverse dependencies? We just want to have openjdk-8 backported to current LTS, not the ability to build all other Java packages with it
As stated in #41 it looks like nobody wants to backport it despite the 544 affected users, and this issue will probably be closed once 16.04 is released.

Dennis Schridde (urzds) wrote :

> If people would like to move this backport forward, I need commitments from people to test backports regularly (average is once per month) as security updates are released.

Where are these backports available? I am currently using "ppa:openjdk-r/ppa" - are you talking about that PPA?

vancha (tjipkevdh) on 2016-03-31
information type: Public → Public Security
Matthias Klose (doko) on 2016-03-31
information type: Public Security → Public
Don-vip (vincent-privat) on 2016-04-21
summary: - Please backport openjdk-8 8u66-b17-1 (universe) from wily
+ Please backport openjdk-8 8u77-b03 (universe) from xenial
Tobiz (pjrobinson) wrote :

openjdk-8 is required by PyDev 5.0.0, see http://http://www.pydev.org/. I've just installed PyDev 5.0.0 on Eclipse Luna (on kubuntu 14.04) and PyDev no longer works. The Eclipse install of PyDev 5.0.0 didn't enforce the openjdk-8 dependency, hence now a mess! A backport of openjdk-8 to 14.04 LTS would be really helpful, and no I don't want to upgrade to 14.10, 15.04 or 16.x I'm happy with 14.04 LTS, for now.

Marius B. Kotsbak (mariusko) wrote :

16.04 LTS is available as a solution if you could upgrade your LTS.

Sodki (henrique-rodrigues) wrote :

Don't get your hopes up, this will never be fixed officially. Upgrade to latest LTS or use the unnoficial PPA from the official devs, that's it.

JD Evora (jdevora) wrote :

I installed Ubuntu on Windows 10 beta and it installs Ubuntu 14.04

Unless the version that gets installed when Windows 10 Anniversary comes out, is 16.04, a lot of people will need this backport

summary: - Please backport openjdk-8 8u77-b03 (universe) from xenial
+ Please backport openjdk-8 from Xenial to Trusty
description: updated
Nfally (nfallycoly) on 2016-09-23
Changed in trusty-backports:
assignee: TJ (tj) → Nfally (nfallycoly)
Narcis Garcia (narcisgarcia) wrote :

I need JVM 1.8 to run current stable version of Eclipse platform.

Ilya G. Ryabinkin (ileyka) wrote :

I need Java 8 to get LanguageTool for LibreOffice running.

David McNeill (davemc) wrote :

+1 for Minecraft Technic Guns and Glory 4.0

thamurath (thamurath) wrote :

March 2017 and still there is no openjdk8 in ubuntu 14.04 ...
any update on this?

Luce Di Ferro (luce) wrote :

Also March 2017 and hoping for openjdk8 in ubuntu 14.04 ...
any update on this?

Ciprian Tomoiaga (cipri.tom) wrote :

it's called LTS for a reason ! People offering to upgrade to 16.04 are just missing the point ...
It's a shame this isn't available

Shivanand (vshivanand) wrote :

+1 Latest version of eclipse requires jdk8

Phil Taprogge (gargath) wrote :

+1 - Latest version of Jenkins from pkg.jenkins-ci.org/debian/ requires Java 8 and silently breaks once updated by apt.

Stephen Warren (srwarren) wrote :

For more info on the Jenkins issue, see the bug report:
https://issues.jenkins-ci.org/browse/JENKINS-43492 - closed as "not a bug":-(
... and the blog post it mentions:
https://jenkins.io/blog/2017/04/10/jenkins-has-upgraded-to-java-8/

This makes it impossible to run Jenkins under Ubuntu 14.04 with OpenJDK. Even the LTS branch of Jenkins will switch to requiring Java 8 in June according to the blog. I could pin the package, but then no security updates for Jenkins. There have been quite a few security updates to Jenkins recently, so I really don't want to do that...

Matthew Buckett (buckett) wrote :

I also ended up here as a result of the Jenkins upgrade to to Java 8. Would be really helpful to have an easily supported way to use Java 8 on 14.04.

Manish Sharma (manishsharma) wrote :

+1

Jim Jones (cnamejj) wrote :

As noted by several other people already, Jenkins releases which are essential for security, performance and feature-availability reasons require Java 8. Since Ubuntu 14.04LTS is still a current, supported release it's difficult to understand how a core component of a server platform like Java would lag behind for such a long time.

Upgrading to Ubuntu 16 is on our roadmap, but it's non-trivial. In the interim, I have no defensible reason to offer people who are legitimately concerned about the delay in our plans to upgrade Jenkins.

Alexander Hall (compuguy1088) wrote :

The PPA that most websites point to from the OpenJDK team was last updated in November 2016 (https://launchpad.net/~openjdk-r/+archive/ubuntu/ppa). A consistently updated repository or official backport is needed.

A broken update was pushed to openjdk-r which is currently breaking all (or at least a fair number of) Trusty Java 8 installs.

https://bugs.launchpad.net/ubuntu/+source/ca-certificates-java/+bug/1706442

The bug was closed as invalid, "not eligible for LTS" which yet again highlights the lack of a proper Java 8 in Trusty.

It is super unhelpful for the Long Term Support release to
1) allow its version of Java to hit EOL with no upgrade path
2) "oh, it's fine, just install it from the openjdk-r repo!"
3) ...and then refuse to support even the most basic functionality (i.e. "it installs"

What's even the point of the LTS designation if it doesn't support running the only supported version of one of the most popular languages on the planet?

On 27.07.2017 00:33, stevenschlansker wrote:
> It is super unhelpful for the Long Term Support release to
> 1) allow its version of Java to hit EOL with no upgrade path

there is no EOL for the openjdk-7 packages in trusty.

Steven Darnell (darnells) wrote :

I'm sure what @stevenschlansker is describing is that Java 7 itself has been EOL since April 2015: https://java.com/en/download/faq/java_7.xml

Although the openjdk-7 packages continues to be supported, it will not receive any new critical patch or security updates, which leaves users open to years-worth of vulnerabilities that have been fixed in Java 8.

Simon Déziel (sdeziel) wrote :

On 2017-07-27 12:24 PM, Steven Darnell wrote:
> I'm sure what @stevenschlansker is describing is that Java 7 itself has
> been EOL since April 2015: https://java.com/en/download/faq/java_7.xml

Stewardship moved from Oracle to Red Hat according to [1]. Red Hat seems
to be committed to keep providing OpenJDK 7 updates till June 2018 [2].

> Although the openjdk-7 packages continues to be supported, it will not
> receive any new critical patch or security updates, which leaves users
> open to years-worth of vulnerabilities that have been fixed in Java 8.

OpenJDK 7 was updated in May 2017 with security fixes. Since the package
is in main for Trusty, it will keep receiving security fixes for the
whole lifetime of the LTS.

HTH,
Simon

1:
https://www.redhat.com/en/about/press-releases/stewardship-openjdk-7-project-shifts-red-hat
2: https://access.redhat.com/articles/1299013

Tobin Davis (gruemaster) wrote :

So, how does Ubuntu continue to test in their environment, if they are not supporting OpenJDK-8 in 14.04? Do they no longer use Jenkins? Because the current Jenkins LTS releases require Jave 8 for their slaves. To add to the 'fun', Oracle has put up additional roadblocks to downloading JRE-8 to slaves automatically, which really puts everything in a bind.

Matthias Klose (doko) wrote :

On 26.10.2017 19:31, Tobin Davis wrote:
> So, how does Ubuntu continue to test in their environment, if they are
> not supporting OpenJDK-8 in 14.04? Do they no longer use Jenkins?

no, jenkins was never a supported package Please correct me if I am wrong.

> Because the current Jenkins LTS releases require Jave 8 for their
> slaves. To add to the 'fun', Oracle has put up additional roadblocks to
> downloading JRE-8 to slaves automatically, which really puts everything
> in a bind.

you are free to update to the next Ubuntu LTS release.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Related questions

Remote bug watches

Bug watches keep track of this bug in other bug trackers.